﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Vista.RPC.Models;

namespace Vista.RPC
{
    [TestClass]
    public class ClientUtilityUnitTest
    {
        [TestMethod]
        public void TestGetVistaSiteById()
        {
            VistaSite vistaSite = RpcClientUtility.GetVistaSiteById("459");
            Console.WriteLine(vistaSite);

            Assert.AreEqual(vistaSite.VistaHostname, "DNS.URL        ");
            Assert.AreEqual(vistaSite.VistaPort, 19201);

            Assert.AreEqual(vistaSite.SiteId, "459");
            Assert.AreEqual(vistaSite.SiteMoniker, "HON");
            Assert.AreEqual(vistaSite.SiteName, "Honolulu, HI");
        }

        [TestMethod]
        public void TestGetVistaSiteById_Fail()
        {
            VistaSite vistaSite = RpcClientUtility.GetVistaSiteById("abcdef");
            Assert.IsNull(vistaSite);
        }

        [TestMethod]
        public void TestGetVistaSiteByMoniker()
        {
            VistaSite vistaSite = RpcClientUtility.GetVistaSiteByMoniker("HON");
            Console.WriteLine(vistaSite);

            Assert.AreEqual(vistaSite.VistaHostname, "DNS.URL        ");
            Assert.AreEqual(vistaSite.VistaPort, 19201);

            Assert.AreEqual(vistaSite.SiteId, "459");
            Assert.AreEqual(vistaSite.SiteMoniker, "HON");
            Assert.AreEqual(vistaSite.SiteName, "Honolulu, HI");
        }
    }
}
