﻿using System;
using System.IO;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Collections.Generic;
using Vista.RPC.Exceptions;
using Vista.RPC.Parameters;
using Vista.RPC.Procedures;
using Vista.RPC.Procedures.XUS;
using Vista.RPC.Procedures.XWB;
using Vista.RPC.Procedures.DDR;

namespace Vista.RPC
{
    [TestClass]
    public class DdrGetsUnitTest1 : BaseRpcTest
    {
        [TestMethod]
        public void TestMethod1()
        {
            RpcClient c = GetRpcClient();
            c.Connect();

            c.Login(TestConfig.Get(Config.TEST_VISTA_ACCESS_CODE).ToSecureString(),
                TestConfig.Get(Config.TEST_VISTA_VERIFY_CODE).ToSecureString());

            Vista.RPC.Procedures.XWB.CreateContext createContext = new CreateContext(CreateContext.CONTEXT_CAPRI.ToSecureString());
            c.Call(createContext);

            bool isValid = createContext.IsValidContext();
            Assert.IsTrue(isValid);

            DdrGets GetsEntry = new DdrGets("2", "8,", "**","E");
            c.Call(GetsEntry);

            System.IO.File.WriteAllText(@"c:\temp\rpc\test.txt", GetsEntry.Response);

            Dictionary<string, FileManFieldValue>.KeyCollection keys = GetsEntry.GetFieldNumbers();
            foreach (String s in keys)
            {
                Console.WriteLine(s + " = " + GetsEntry.GetFieldValue(s));
            }

            c.Disconnect();
        }

        [TestMethod]
        public void TestInternalValues()
        {
            var client = ConnectAndLogin();
            client.CreateContext(CreateContext.CONTEXT_CAPRI.ToSecureString());

            var getsEntry = new DdrGets("200", "28245,", "**", "IE");
            client.Call(getsEntry);

            File.WriteAllText(@"c:\temp\rpc\test.txt", getsEntry.Response);

            Console.WriteLine(getsEntry.GetFieldValue("2"));
            Console.WriteLine(getsEntry.GetFieldValue("2", false));

            client.Disconnect();
        }
    }
}
