﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Vista.RPC.Procedures.XOBE
{
    [TestClass]
    public class EsigSetDataUnitTest1 : BaseRpcTest
    {
        [TestMethod]
        public void TestSuccess()
        {
            var rpcClient = ConnectAndLogin();

            var remoteProcedure = new ElectronicSignatureSetDetails(initials: "TEST", signatureBlockPrintedName: "CHRIS U UYEHARA",
                signatureBlockTitle: "TEST ANALYST", voicePagerNumber: "888-555-8888");

            rpcClient.Call(remoteProcedure);

            Assert.IsTrue(remoteProcedure.IsSetDetailsSuccessful());

            Console.WriteLine("Response: " + remoteProcedure.Response);
        }

        [TestMethod]
        public void TestFailure()
        {
            var rpcClient = ConnectAndLogin();

            var remoteProcedure = new ElectronicSignatureSetDetails(initials: "FAIL", signatureBlockPrintedName: "CHRIS U UYEHARA",
                signatureBlockTitle: "FAIL ANALYST", voicePagerNumber: "aaaaaaaaaa");

            rpcClient.Call(remoteProcedure);

            Console.WriteLine("Response: " + remoteProcedure.Response); 
            
            Assert.IsFalse(remoteProcedure.IsSetDetailsSuccessful());          
        }
    }
}
