﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Vista.RPC.Procedures.XUS
{
    [TestClass]
    public class DivisionSetUnitTest1 : BaseRpcTest
    {
        [TestMethod]
        public void DivisionSetSuccess()
        {
            var rpcClient = ConnectAndLogin();
            var remoteProcedure = new DivisionSet("120276");

            rpcClient.Call(remoteProcedure);

            Assert.IsTrue(remoteProcedure.IsDivisionSet); 
            Console.WriteLine(remoteProcedure.Response);
            Assert.IsTrue(remoteProcedure.Response.Length > 0);                        
        }

        [TestMethod]
        public void DivisionSetFailure()
        {
            var rpcClient = ConnectAndLogin();
            var remoteProcedure = new DivisionSet("999999120276");

            rpcClient.Call(remoteProcedure);

            Assert.IsTrue(remoteProcedure.IsDivisionSet == false);
            Console.WriteLine(remoteProcedure.Response);
            Assert.IsTrue(remoteProcedure.Response.Length > 0);
        }
    }
}
