﻿using System;
using System.Security;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Vista.RPC.Procedures.XUS
{
    [TestClass]
    public class SignonSetupUnitTest1 : BaseRpcTest
    {
        [TestMethod]
        public void TestMethod1()
        {
            const string VRAM_KEY = "It's better to light a candle than curse the the darkness";
            SecureString bseToken;

            var rpcClient = ConnectAndLogin();

            var division = new DivisionGet();
            rpcClient.Call(division);

            var rpc = new VisitorSet();
            rpcClient.Call(rpc);

            Assert.IsTrue(rpc.GetVisitorToken() != null);
            Assert.IsTrue(rpc.GetVisitorToken().Length > 0);
            Console.WriteLine("BSE token: " + rpc.GetVisitorToken());
            bseToken = rpc.GetVisitorToken().ToSecureString();

            rpcClient.Disconnect();

            var logger = RpcLogging.CreateLogger<RpcClient>();
            rpcClient = new RpcClient(logger, "DNS.URL        ", PORT, false);
            rpcClient.Connect();

            var signon = new SignonSetup(VRAM_KEY.ToSecureString(), bseToken);
            rpcClient.Call(signon);

            Console.WriteLine(signon.Response); 
            
            var token = new TokenGet();
            rpcClient.Call(token);

            Console.WriteLine(token.Token);
        }
        
    }
}
