﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Vista.RPC.Procedures.XUS
{
    [TestClass]
    public class TokenGetUnitTest1 : BaseRpcTest
    {
        [TestMethod]
        public void TestGettingToken()
        {
            var rpcClient = ConnectAndLogin(true);

            var rpc = new TokenGet();
            rpcClient.Call(rpc);

            Console.WriteLine(rpc.Token);
            Assert.IsNotNull(rpc.Token);
            Assert.IsTrue(rpc.Token.Length > 10);
            Assert.IsTrue(rpc.Token.Contains("XWB"));
        }

        [TestMethod]
        public void TestTokenUsingRpc()
        {
            var rpcClient = ConnectAndLogin(true);

            var rpc = new TokenGet();
            rpcClient.Call(rpc);

            string token = rpc.Token;
            Console.WriteLine(rpc.Token);

            rpcClient.Disconnect();

            Assert.IsTrue(rpcClient.Connected == false);

            rpcClient.Connect();
            var signonSetup = new SignonSetup();
            rpcClient.Call(signonSetup);

            Console.WriteLine(signonSetup.Response);

            var autoSignon = new AvCode(token.ToSecureString());

            rpcClient.Call(autoSignon);
            Console.WriteLine("Auto Signon:\r\n" + autoSignon.Response);

            Assert.IsTrue(autoSignon.LoginResponse.LoggedIn);
            Assert.IsTrue(!string.IsNullOrEmpty(autoSignon.LoginResponse.LoggedInDuz));
            Assert.IsTrue(autoSignon.LoginResponse.LoggedInDuz != "0");
        }
    }
}
