﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Vista.RPC.Parameters;
using Vista.RPC.Procedures.XUS;

namespace Vista.RPC.Procedures.XWB
{
    [TestClass]
    public class GetVariableValueUnitTest1 : BaseRpcTest
    {
        [TestMethod]
        public void TestGetVariableValue()
        {
            var client = ConnectAndLogin(true);

            var getVariableValue = new RemoteProcedure("XWB GET VARIABLE VALUE");
            getVariableValue.AddParameter(new ReferenceParameter("$zversion"));

            client.Call(getVariableValue);

            if (getVariableValue.Response.Contains("The remote procedure XWB GET VARIABLE VALUE is not registered"))
            {
                Assert.Fail(getVariableValue.Response);
            }

            Console.WriteLine("GVV: " + getVariableValue.Response);

            client.Disconnect();
        }
    }
}
