﻿using System;
using System.Configuration;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Vista.RPC
{
    public enum Config
    {
        TEST_VISTA_HOSTNAME,
        TEST_VISTA_PORT,
        TEST_VISTA_ACCESS_CODE,
        TEST_VISTA_VERIFY_CODE,
        TEST_VISTA_BSE_KEY,
            
        CLAIMS_HOSTNAME,
        CLAIMS_PORT,
        CLAIMS_ACCESS_CODE,
        CLAIMS_VERIFY_CODE,
        CLAIMS_BSE_KEY,
            
        TEST_CLAIMS_HOSTNAME,
        TEST_CLAIMS_PORT,
        TEST_CLAIMS_ACCESS_CODE,
        TEST_CLAIMS_VERIFY_CODE,
        TEST_CLAIMS_BSE_KEY,

        TEST_REPLACE_ME
    };
    
    [TestClass]
    public class TestConfig
    {
        public static string ErrorMessage = "unit test config is incomplete - please update App.config";

        public static string Get(Config config)
        {
            var configValue = ConfigurationManager.AppSettings.Get(config.ToString());
            if (configValue == "REPLACE_ME")
            {
                throw new ArgumentException(ErrorMessage, config.ToString());
            }

            return configValue;
        }

        [TestMethod]
        public void ReadAppConfig()
        {
            var testVistaHostname = Get(Config.TEST_CLAIMS_HOSTNAME);
            Assert.IsNotNull(testVistaHostname);
            Assert.IsTrue(testVistaHostname.Length > 0);

            if (testVistaHostname == "REPLACE_ME")
            {
                Assert.Fail(ErrorMessage);
            }

            var testVistaPort = Get(Config.TEST_CLAIMS_PORT);
            Assert.IsNotNull(testVistaPort);
            Assert.IsTrue(testVistaPort.Length > 0);
            
            if (testVistaPort == "REPLACE_ME")
            {
                Assert.Fail(ErrorMessage);
            }

            try
            {
                var test = Get(Config.TEST_REPLACE_ME);
            }
            catch (ArgumentException e)
            {
                Assert.IsTrue(e.Message.Contains(ErrorMessage));
            }
            catch (Exception e)
            {
                Assert.Fail("no other exception should be thrown");
            }
        }
    }
}
