﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Extensions.Logging;

namespace Vista.RPC.Exceptions
{
    [Serializable]
    public class CallException : RpcSocketException
    {
        private ILogger logger = RpcLogging.CreateLogger<CallException>();

        public CallException(string message) : base(message)
        {
            logger.LogError($"rpc failed: {message}");
        }

        public CallException(string message, Exception innerException) : base(message, innerException)
        {
            logger.LogError(innerException,$"rpc failed: {message}");
        }
    }
}
