﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Extensions.Logging;

namespace Vista.RPC.Exceptions
{
    [Serializable]
    public class ConnectException : RpcSocketException
    {
        private ILogger logger = RpcLogging.CreateLogger<ConnectException>();

        public ConnectException(string message) : base(message)
        {
            logger.LogError($"connection failure: {message}");
        }

        public ConnectException(string message, Exception innerException) : base(message, innerException)
        {
            logger.LogError(innerException, $"connection failure: {message}");
        }
    }
}
