﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Extensions.Logging;

namespace Vista.RPC.Exceptions
{
    [Serializable]
    public class RpcSocketException : Exception
    {
        private ILogger logger = RpcLogging.CreateLogger<RpcSocketException>();

        public RpcSocketException(string message) : base(message)
        {
            logger.LogError($"socket exception: {message}");
        }

        public RpcSocketException(string message, Exception innerException) : base(message, innerException)
        {
            logger.LogError(innerException, $"socket exception: {message}");
        }
    }
}
