﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Extensions.Logging;

namespace Vista.RPC.Exceptions
{
    [Serializable]
    public class SiteNotFoundException : Exception
    {
        private ILogger logger = RpcLogging.CreateLogger<SiteNotFoundException>();

        public SiteNotFoundException(string message) : base(message)
        {
            logger.LogError($"site not found: {message}");
        }

        public SiteNotFoundException(string message, Exception innerException) : base(message, innerException)
        {
            logger.LogError(innerException, $"site not found: {message}");
        }
    }
}
