﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security;
using System.Text;
using System.Threading.Tasks;
using Vista.RPC.Models;
using Vista.RPC.Procedures;

namespace Vista.RPC
{
	public interface IRpcClient : IDisposable
	{        
		LoginResponse Login(SecureString accessCode, SecureString verifyCode, SecureString menuOptionOrBrokerContext);
		LoginResponse Login(SecureString accessCode, SecureString verifyCode);

		void Call(IRemoteProcedure remoteProcedure);

		void CallAndDisconnect(IRemoteProcedure rpc);

		void Disconnect();

		void Connect();

		bool CreateContext(SecureString contextString);

		bool Connected { get; }
	}
}
