﻿using System;
using System.Text;
using Microsoft.Extensions.Logging;

namespace Vista.RPC.Parameters
{
    public class GlobalParameter : Parameter, IParameter
    {
        private ILogger logger = RpcLogging.CreateLogger<GlobalParameter>();

        public string Value
        {
            get;
            private set;
        }

        public string Key
        {
            get;
            private set;
        }

        public const string BROKER_VALUE = "3";

        public GlobalParameter(String key, String value)
        {
            logger.LogDebug($"GlobalParameter : key ${key}, value ${value}");

            StringBuilder stringBuilder = new StringBuilder();

            var tryParse = int.TryParse(key, out var parsedInt);

            if (tryParse)
            {
                stringBuilder.Append(parsedInt);
            }
            else
            {
                stringBuilder.Append(key);

                if (!key.StartsWith("\""))
                {
                    stringBuilder.Insert(0, "\"");
                }
                if (!key.EndsWith("\""))
                {
                    stringBuilder.Append("\"");
                }
            }

            if (String.IsNullOrEmpty(value))
            {
                value = "\u0001";
            }

            Key = key;
            Value = value;
        }

        public string ToParameter()
        {
            var stringBuilder = new StringBuilder();
            stringBuilder.Append(BROKER_VALUE);
            stringBuilder.Append(Key.PackString(PACK_STRING_LENGTH));
            stringBuilder.Append(Value.PackString(PACK_STRING_LENGTH));
            stringBuilder.Append("f");

            return stringBuilder.ToString();
        }
    }
}
