﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Vista.RPC.Parameters
{
    public class ListParameter : Parameter, IParameter
    {
        public Dictionary<String, String> Value
        {
            get; 
            private set;
        }

        public const string BROKER_VALUE = "2";

        public ListParameter(Dictionary<String,String> value)
        {
            Value = value;
        }

        public string ToParameter()
        {
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.Append(BROKER_VALUE);

            if (Value == null || Value.Count == 0)
            {
                stringBuilder.Append("".PackString(PACK_STRING_LENGTH));
                stringBuilder.Append("f");
            }
            else
            {
                foreach (String key in Value.Keys)
                {
                    String keyValue = Value[key];

                    if (String.IsNullOrEmpty(keyValue))
                    {
                        keyValue = "\u0001";
                    }

                    stringBuilder.Append(key.PackString(PACK_STRING_LENGTH));
                    stringBuilder.Append(keyValue.PackString(PACK_STRING_LENGTH));
                    stringBuilder.Append("t");
                }
            }

            stringBuilder[stringBuilder.Length - 1] = 'f'; /* replace last t with f */

            return stringBuilder.ToString();
        }
    }
}
