﻿using System;
using System.Security;
using System.Text;

namespace Vista.RPC.Parameters
{
    public class LiteralParameter : Parameter, IParameter
    {
        public string Value
        {
            get;
            private set;
        }

        public SecureString SecureValue
        {
            get;
            private set;
        }

        public const string BROKER_VALUE = "0";

        public LiteralParameter(String value)
        {
            Value = value;
        }

        public LiteralParameter(SecureString secureValue)
        {
            SecureValue = secureValue;
        }

        public string ToParameter()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append(BROKER_VALUE);

            sb.Append(SecureValue != null
                ? SecureValue.ToClearText().PackString(PACK_STRING_LENGTH)
                : Value.PackString(PACK_STRING_LENGTH));

            sb.Append("f");

            return sb.ToString();
        }
    }
}
