﻿using System;
using System.Collections.Generic;
using Vista.RPC.Parameters;

namespace Vista.RPC.Procedures.DDR
{
    public class DdrFinder : RemoteProcedure
    {
        public DdrFinder(string file, string lookupValue, string iens = "", string fields = "", string flags = "", 
            string maxRecords = "", string indexes = "", string screen = "", string identifier = "") : base("DDR FINDER")
        {
            arguments = new Dictionary<string, string>();

            arguments.Add("\"FILE\"", file);
            arguments.Add("\"VALUE\"", lookupValue);

            if(!String.IsNullOrEmpty(iens))
                arguments.Add("\"IENS\"", iens);
            if(!String.IsNullOrEmpty(fields))
                arguments.Add("\"FIELDS\"", fields);
            if(!String.IsNullOrEmpty(flags))
                arguments.Add("\"FLAGS\"", flags);
            if(!String.IsNullOrEmpty(maxRecords))
                arguments.Add("\"MAX\"", maxRecords);
            if(!String.IsNullOrEmpty(indexes))
                arguments.Add("\"XREF\"", indexes);
            if(!String.IsNullOrEmpty(screen))
                arguments.Add("\"SCREEN\"", screen);
            if(!String.IsNullOrEmpty(identifier))
                arguments.Add("\"ID\"", identifier);

            var listParameter = new ListParameter(arguments);
            AddParameter(listParameter);
        }

        private Dictionary<string, string> arguments;

        public override void AfterCall()
        {
            throw new NotImplementedException();
        }
    }

}
