﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Vista.RPC.Procedures.DDR
{
    public class FileManDataArray : Vista.RPC.Procedures.DDR.IFileManDataArray
    {
        public FileManDataArray() 
        {
            filemanDataArray = new Dictionary<string, Dictionary<string, Dictionary<string, string>>>();
        }

        private Dictionary<string, Dictionary<string, Dictionary<string, string>>> filemanDataArray = null;

        public void Add(string FileNumber, string Iens, string FieldNumber, string Value)
        {
            if(!filemanDataArray.ContainsKey(FileNumber))
            {
                filemanDataArray.Add(FileNumber, new Dictionary<string,Dictionary<string,string>>());
            }
            if(!filemanDataArray[FileNumber].ContainsKey(Iens))
            {
                filemanDataArray[FileNumber].Add(Iens, new Dictionary<string,string>());
            }
            
            filemanDataArray[FileNumber][Iens][FieldNumber] = Value;
        }

        public int Count
        {
            get { return filemanDataArray.Count; }
        }

        public void Remove(string FileNumber, string Iens, string FieldNumber)
        {
            if (filemanDataArray.ContainsKey(FileNumber))
            {
                if (filemanDataArray[FileNumber].ContainsKey(Iens))
                {
                    if (filemanDataArray[FileNumber][Iens].ContainsKey(FieldNumber))
                    {
                        filemanDataArray[FileNumber][Iens].Remove(FieldNumber);

                        if (filemanDataArray[FileNumber][Iens].Count() <= 0)
                        {
                            filemanDataArray[FileNumber].Remove(Iens);

                            if (filemanDataArray[FileNumber].Count <= 0)
                            {
                                filemanDataArray.Remove(FileNumber);
                            }
                        }
                    }
                }
            }
        }

        public string Get(string FileNumber, string Iens, string FieldNumber, string Value)
        {
            if (filemanDataArray.ContainsKey(FileNumber))
            {
                if (filemanDataArray[FileNumber].ContainsKey(Iens))
                {
                    if (filemanDataArray[FileNumber][Iens].ContainsKey(FieldNumber))
                    {
                        return filemanDataArray[FileNumber][Iens][FieldNumber];
                    }
                }
            }

            return null;
        }

        public List<string> ToFDA()
        {
            List<string> fdaRoot = new List<string>();

            foreach (string fileNumber in filemanDataArray.Keys)
            {
                foreach (string iens in filemanDataArray[fileNumber].Keys)
                {
                    foreach (string fieldNumber in filemanDataArray[fileNumber][iens].Keys)
                    {
                        fdaRoot.Add(fileNumber + "^" + fieldNumber + "^" + iens + "^" + filemanDataArray[fileNumber][iens][fieldNumber]);
                    }
                }
            }

            return fdaRoot;
        }
    }
}
