﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security;
using System.Text;
using System.Threading.Tasks;
using Vista.RPC.Parameters;

namespace Vista.RPC.Procedures.ORWU
{
    /// <summary>
    /// This remote procedure checks to see if a given eSignature matches VistA's eSignature.
    /// </summary>
    public class ValidSig : RemoteProcedure
    {
        public ValidSig(string unencryptedEsignature)
            : base("ORWU VALIDSIG")
        {
            AddParameter(new LiteralParameter(unencryptedEsignature.ToSecureString()));
        }

        public override void AfterCall()
        {
            if (Response == "1")
                IsValidESig = true;
            else
                IsValidESig = false;
        }

        public bool IsValidESig
        {
            get;
            private set;
        }
    }
}
