﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Vista.RPC.Procedures
{
    public class RawRemoteProcedure : IRemoteProcedure
    {
        public string Payload
        {
            get;
            protected set;
        }

        /// <summary>
        /// Build an empty remote procedure; programmer will complete implementation details
        /// </summary>
        public RawRemoteProcedure() { }

        /// <summary>
        /// Build a remote procedure using the given value
        /// </summary>
        /// <param name="payload">The raw value of the remote procedure to pass</param>
        public RawRemoteProcedure(string payload)
        {
            Payload = payload;
        }

        public sealed override string ToProcedure()
        {
            return Payload;
        }

        public override void AfterCall()
        {
            
        }
    }
}
