﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Vista.RPC.Parameters;

namespace Vista.RPC.Procedures.XOBE
{
    public class ElectronicSignatureSetCode : RemoteProcedure
    {
        /// <summary>
        /// Sets the logged in user's electronic signature code.
        /// </summary>
        /// <param name="unencryptedElectronicSignature"></param>
        public ElectronicSignatureSetCode(string unencryptedElectronicSignature) : base("XOBE ESIG SET CODE")
        {
            AddParameter(new LiteralParameter(unencryptedElectronicSignature.ToSecureString()));     
        }

        public bool IsElectronicSignatureSet()
        {
            if(Response.Trim().Equals("1"))
                return true;

            return false;
        }

        public string GetMessage()
        {
            switch (Response.Trim())
            {
                case "1":
                    return "new electronic signature updated successfully";
                case "0":
                    return "new electronic signature is not valid";
                case "-1":
                    return "new electronic signature is the same as the old one";
                case "-2":
                    return "the signed on user [DUZ] doesn't refer to a valid user";
            }

            return "unknown error: " + Response.Trim();
        }
    }
}
