﻿using System;
using Vista.RPC.Models;
using Vista.RPC.Parameters;

namespace Vista.RPC.Procedures.XUS
{
    /// <summary>
    /// This remote procedure sets the user's signon division.
    /// </summary>
    public class DivisionSet : RemoteProcedure
    {
        public DivisionSet(Division division) : base("XUS DIVISION SET")
        {
            if(null == division)
                throw new ArgumentNullException("division");

            if(String.IsNullOrEmpty(division.Ien))
                throw new ArgumentNullException("division");

            AddParameter(new LiteralParameter(division.Ien));
        }

        public DivisionSet(string divisionIen) : base("XUS DIVISION SET")
        {
            if(String.IsNullOrEmpty(divisionIen))
                throw new ArgumentNullException("divisionIen");

            AddParameter(new LiteralParameter(divisionIen));
        }

        public override void AfterCall()
        {
            if (Response.Trim().Equals("1"))
                IsDivisionSet = true;
            else
                IsDivisionSet = false;
        }

        public bool IsDivisionSet
        {
            get; private set;
        }
    }
}
