﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security;
using System.Text;
using Vista.RPC.Parameters;

namespace Vista.RPC.Procedures.XUS
{
    public class SignonSetup : RemoteProcedure
    {
        public SignonSetup() : base("XUS SIGNON SETUP")
        {
        }

        public SignonSetup(SecureString bseApplicationPassPhrase, SecureString bseToken) : base("XUS SIGNON SETUP")
        {
            if(bseApplicationPassPhrase == null)
                throw new ArgumentNullException(nameof(bseApplicationPassPhrase));
            if(bseToken == null)
                throw new ArgumentNullException(nameof(bseToken));
            
            var upHat = new SecureString();
            upHat.AppendChar('^');

            var compiledToken = bseApplicationPassPhrase.Concat(upHat, bseToken);
            
            LiteralParameter literal = new LiteralParameter("-35^" + compiledToken.ToVistaEncrypt());
            AddParameter(literal);            
        }
    }
}
