﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Vista.RPC.Parameters;

namespace Vista.RPC.Procedures.XUS
{
    /// <summary>
    /// This remote procedure fetches the details of a BSE Token. Useful for debugging BSE issues.
    /// </summary>
    public class VisitorGet : RemoteProcedure
    {
        /// <summary>
        /// Gets the visitor information using the given BSE token.
        /// </summary>
        /// <param name="bseToken">The token must be issued the same day as it is being fetched.</param>
        public VisitorGet(string bseToken) : base("XUS GET VISITOR")
        {
            if(String.IsNullOrEmpty(bseToken))
                throw new ArgumentNullException("bseToken");

            AddParameter(new LiteralParameter(bseToken));
        }

        public string GetVisitorToken()
        {
            return Response;
        }
    }
}
