﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;

namespace Vista.RPC.Procedures.XWB
{

    public class Connect : RawRemoteProcedure
    {
        /// <summary>
        /// Connects to a VistA RPC broker using the "NEW" style. For more information regarding the "NEW"
        /// style connection; please review the documentation available at http://www.va.gov/vdl/application.asp?appid=23
        /// </summary>
        public Connect(string ipAddress, string hostName)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("[XWB]10304\nTCPConnect50");
            sb.Append(ipAddress.PackString(3));
            sb.Append("f0");
            sb.Append(Convert.ToString(0).PackString(3));
            sb.Append("f0");
            sb.Append(hostName.PackString(3));
            sb.Append("f\x04");

            Payload = sb.ToString();
        }

        public bool ConnectionAccepted()
        {
            if (Response.Equals("accept"))
            {
                return true;
            }

            return false;
        }
    }
}
