﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Security;
using Vista.RPC.Parameters;

namespace Vista.RPC.Procedures.XWB
{

    public class CreateContext : RemoteProcedure
    {
        public const String CONTEXT_AUDIOGRAM_DATA = "ACKQROES3";
        public const String CONTEXT_AUDIOGRAM_EDIT = "ACKQROES3E";
        public const String CONTEXT_CPRS = "OR CPRS GUI CHART";
        public const String CONTEXT_SIGNON = "XUS SIGNON";
        public const String CONTEXT_CAPRI = "DVBA CAPRI GUI";
        public const String CONTEXT_ESIG = "XOBE ESIG USER";
        public const String CONTEXT_EVENT_CAPTURE = "EC GUI CONTEXT";
        public const String CONTEXT_KERNEL_ALERTS = "XQAL GUI ALERTS";
        public const String CONTEXT_MENTAL_HEALTH_ASSISTANT = "YS BROKER1";
        public const String CONTEXT_PCE_RECORD_MANAGER = "VEJD PCE RECORD MANAGER";
        public const String CONTEXT_QUADRAMED = "VEJD VG FOR QM MEDREC";
        public const String CONTEXT_VRAM = "KPA VRAM GUI";

        /// <summary>
        /// Connects to a VistA RPC broker using the "NEW" style. For more information regarding the "NEW"
        /// style connection; please review the documentation available at http://www.va.gov/vdl/application.asp?appid=23
        /// </summary>
        public CreateContext(SecureString context) : base("XWB CREATE CONTEXT")
        {
            if (context == null)
            {
                throw new ArgumentNullException(nameof(context));
            }

            var encryptedContext = context.ToVistaEncrypt();
            LiteralParameter p = new LiteralParameter(encryptedContext);
            AddParameter(p);
        }

        public bool IsValidContext()
        {
            return Response.Equals("1");
        }
    }
}
