﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Extensions.Logging;

namespace Vista.RPC
{
	public class RpcClientFactory : IRpcClientFactory
    {
        private readonly ILogger _logger;

        public RpcClientFactory(ILogger logger)
        {
            _logger = logger ?? throw new ArgumentNullException(nameof(logger));
        }

		public IRpcClient Create(string hostname, int port, bool preventRpcTimeout = true)
        {
			return new RpcClient(_logger, hostname, port, preventRpcTimeout);
		}
	}
}
