﻿/*Create generic error info handling proc for try...catch formations*/

-- =============================================
-- Description:	Retrieves error information.  Expect to be able to use in conjunction with TRY...CATCH constructs in stored procs.
--				See: ms-help://MS.SQLCC.v9/MS.SQLSVR.v9.en/udb9/html/3a5711f5-4f6d-49e8-b1eb-53645181bc40.htm, or look for "Using Try...Catch" in help.
-- =============================================
CREATE FUNCTION [dbo].[ufnGetErrorInfo]() RETURNS TABLE
AS
RETURN 
(
SELECT 
        ERROR_NUMBER() AS ErrorNumber,
        ERROR_SEVERITY() AS ErrorSeverity,
        ERROR_STATE() AS ErrorState,
        ERROR_PROCEDURE() AS ErrorProcedure,
        ERROR_LINE() AS ErrorLine,
        ERROR_MESSAGE() AS ErrorMessage

);