﻿
-- =============================================
-- Description:	Identifies true/false if the user is a national user
-- =============================================
CREATE FUNCTION [dbo].[ufnIsNationalUserName]
(
	@userName varchar(50),
	@applicationIds tinyint
)
RETURNS bit
AS
BEGIN
	DECLARE @isNationalUser bit,
			@accessLevelId tinyint;

	SET @isNationalUser = 0;
	SELECT @accessLevelId = dbo.ufnGetAccessLevelConstant('National');
	
	IF @userName Is Null Or @userName = ' '
		BEGIN
			SET @isNationalUser = 1;
		END
	ELSE
		BEGIN
			IF EXISTS (SELECT UserName 
					    FROM UserRoles
						INNER JOIN Users ON UserRoles.UserID = Users.UserID
						WHERE UserName = @userName 
						AND AccessStatus = 'APPROVED' 
						AND AccessLevelID = @accessLevelId
						AND (ApplicationID In(SELECT [value] FROM ufnSplit(',', @applicationIds)) OR @applicationIds IS NULL))
				BEGIN
					SET @isNationalUser = 1;
				END
		END
	RETURN @isNationalUser
END


GO


