﻿-- =============================================
-- Description:	Creates an 'InLine' Table Valued Function (TVF).  See http://code.msdn.microsoft.com/SQLExamples/Wiki/View.aspx?title=StringArrayInput
--
-- Maintenance Log:
--
-- Update By     Update Date     Description
-- -----------     ---------     ----------------------------
-- Karen Bells     03/30/09	     Created
-- =============================================
--
CREATE FUNCTION dbo.ufnSplit 
   (  @delimiter varchar(5), 
      @list      varchar(max)
   ) 
   RETURNS @resultTable table 
      (  RowID   smallint IDENTITY(1,1), 
         [Value] varchar(250) 
      ) 
AS 
   BEGIN
    
      DECLARE @lenString int ;
 
      WHILE LEN(@list) > 0 
         BEGIN 
         
            SELECT @lenString = 
               (CASE Charindex(@delimiter, @list) 
                   WHEN 0 THEN LEN(@list) 
                   ELSE (Charindex(@delimiter, @list) - 1)
                END
               ) ;
                                
            INSERT INTO @resultTable 
               SELECT LTRIM(RTRIM(Substring(@list, 1, @lenString)));
                
            SELECT @list = 
               (CASE (LEN(@list) - @lenString) 
                   WHEN 0 THEN '' 
                   ELSE Right(@list, LEN(@list) - @lenString - 1) 
                END
               ) ;
         END
      RETURN 
   END