﻿-- =============================================
-- Description:	Returns list of stations.
--
-- Maintenance Log:
--
-- Update By     Update Date     Description
-- -----------     ---------     ----------------------------
-- =============================================
CREATE PROCEDURE [dbo].[uspGetStations]
	@visnIds varchar(max)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
	
	BEGIN TRY
		SELECT DISTINCT Visns.VISNCode, StationID, 'V' + CAST(Visns.VISNCode AS varchar) + ': ' + Station3N AS StationLabel, StationName
			FROM Stations
			LEFT OUTER JOIN Visns ON Visns.VisnID = Stations.VisnID
			WHERE (Visns.VisnCode In(SELECT [value] FROM ufnSplit(',', @visnIds)) OR @visnIds IS NULL)

		--Clone this just in case the client utterly detests the new naming convention
		--SELECT DISTINCT VISNCode, StationNumber, 'V' + CAST(VISNCode AS varchar) + ': ' + StationNumber + ' (' + StationName + ')' AS StationLabel
		--	FROM VistaStations
		--	WHERE (VisnCode In(SELECT [value] FROM ufnSplit(',', @visnIds)) OR @visnIds IS NULL)
			--UNION
			--SELECT NULL AS VisnCode, NULL AS StationNumber, '[All]' AS StationLabel
			ORDER BY Visns.VisnCode, StationName
	END TRY

	BEGIN CATCH
		PRINT 'There was an error getting stations' + CHAR(13)
		SELECT * FROM dbo.ufnGetErrorInfo()
		EXEC uspRaiseErrorInfo
	END CATCH
END
GO

