﻿
-- =============================================
-- Description:	Returns the MS_Descriptions of fields in the database.
--				See http://databases.aspfaq.com/schema-tutorials/schema-how-do-i-show-the-description-property-of-a-column.html
-- =============================================
CREATE PROCEDURE [dbo].[uspRptDataDictionary]
@tableIDs varchar (MAX)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	SELECT  
	    c.object_id,
		[Table Name] = OBJECT_NAME(c.object_id), 
		[Column Name] = c.name, 
		[Description] = ex.value  
	FROM  
		sys.columns c  
	LEFT OUTER JOIN  
		sys.extended_properties ex  
	ON  
		ex.major_id = c.object_id 
		AND ex.minor_id = c.column_id  
		AND ex.name = 'MS_Description'  
	WHERE  
		OBJECTPROPERTY(c.object_id, 'IsMsShipped') = 0  
		AND OBJECT_NAME(c.object_id) NOT LIKE '!_%' ESCAPE '!'
		AND (ISNULL(c.object_id, 0) In(SELECT [Value] FROM ufnSplit(',', @tableIDs)) OR @tableIDs IS NULL)
	ORDER  
		BY OBJECT_NAME(c.object_id), c.column_id;
END
