﻿-- =============================================
-- Description:	Returns list of region to tie into the reporting.
-- =============================================
CREATE PROCEDURE [dbo].[uspRptGetUserRegionsList]
	@userId int,
	@applicationIds varchar(max)
AS
	DECLARE @resultsTable table
	(
		RowID int,
		ApplicationID tinyint,
		RegionID tinyint,
		RegionCode varchar(10),
		RegionName varchar(50),
		Inactive bit
	);

BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	BEGIN TRY

		INSERT INTO @resultsTable (RowID, ApplicationID, RegionID, RegionCode, RegionName, Inactive)
		EXEC uspGetUserRegions @userId, @applicationIds;

		SELECT DISTINCT RegionID, RegionCode, RegionName
			FROM @resultsTable
			--UNION SELECT 0 AS RegionID, NULL AS RegionCode, '[All]' AS 'RegionName'
			ORDER BY  RegionID, RegionName;

	END TRY
	BEGIN CATCH
		PRINT 'There was an while getting user region reporting list' + CHAR(13);
		SELECT * FROM dbo.ufnGetErrorInfo();
		EXEC uspRaiseErrorInfo;
	END CATCH
END
GO