﻿

-- =============================================
-- Description:	Returns list of stations; ties into the reporting.
-- =============================================
CREATE PROCEDURE [dbo].[uspRptGetUserStationsList]
	@visnIds varchar(max), 
	@userId int,
	@applicationIds varchar(max)
AS
	DECLARE @resultsTable table
	(
		RowID int,
		ApplicationID tinyint,
		VisnID tinyint,
		StationID smallint,
		ParentStationID smallint,
		Station3N varchar(10),
		Station6A varchar(10),
		StationDisplayName varchar(100),
		StationName varchar(100),
		IsParent bit,
		Inactive bit
	);
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	BEGIN TRY
		INSERT INTO @resultsTable (RowID, ApplicationID, VisnID, StationID, ParentStationID, Station3N, Station6A
				, StationDisplayName, StationName, IsParent, Inactive)
		EXEC uspGetUserStations @userId, @applicationIds;

		SELECT DISTINCT VisnID, StationID, ParentStationID, Station3N, Station6A, 
			StationDisplayName, StationName, IsParent, Inactive
		FROM @resultsTable
		WHERE (VisnID In(SELECT [Value] FROM ufnSplit(',', @visnIds)) OR @visnIds IS NULL)
		--UNION SELECT 0 AS VisnID
		--, NULL AS StationID, NULL AS ParentStationID, NULL AS Station3N, NULL AS Station6A
		--, '[All]' AS StationDisplayName, '[All]' AS StationName, 1 AS IsParent, 0 AS Inactive
		ORDER BY VisnID, Station3N, StationDisplayName;
	END TRY
	BEGIN CATCH
		PRINT 'There was an while getting user station list' + CHAR(13);
		SELECT * FROM dbo.ufnGetErrorInfo();
		EXEC uspRaiseErrorInfo;
	END CATCH
END
GO