﻿-- =============================================
-- Description:	Returns list of Visns ties into the reporting.
-- =============================================
CREATE PROCEDURE [dbo].[uspRptGetUserVisnsList]
	@regionIds varchar(max),
	@userId int,
	@applicationIds varchar(max)
AS
	DECLARE @resultsTable table
	(
		RowID int,
		ApplicationID tinyint,
		RegionID tinyint,
		AltRegionID tinyint,
		VisnID tinyint,
		VisnCode varchar(10),
		VisnDisplayName varchar(50),
		VisnName varchar(100),
		Inactive bit
	);
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	BEGIN TRY

		INSERT INTO @resultsTable (RowID, ApplicationID, RegionID, AltRegionID, VisnID, VisnCode, 
			VisnDisplayName, VisnName, Inactive)
		EXEC uspGetUserVisns @userId, @applicationIds;

		SELECT DISTINCT RegionID, AltRegionID, VisnID, VisnCode, VisnDisplayName, VisnName
			FROM @resultsTable
			WHERE (RegionID In(SELECT [Value] FROM ufnSplit(',', @regionIds)) OR @regionIds IS NULL)
			--UNION SELECT 0 AS RegionID, NULL AS VisnID, NULL AS VisnCode, 
			--'[All]' AS 'VisnDisplayName', '[All]' AS VisnName
			ORDER BY  VisnID, VisnDisplayName;


	END TRY
	BEGIN CATCH
		PRINT 'There was an while getting user VISN reporting list' + CHAR(13);
		SELECT * FROM dbo.ufnGetErrorInfo();
		EXEC uspRaiseErrorInfo;
	END CATCH
END
GO