﻿
-- =============================================
-- Description:	Returns detail data for from Key Replication logs for reporting.
-- =============================================
CREATE PROCEDURE [dbo].[uspRptReplicationLogDetails]
	-- Add the parameters for the stored procedure here
	@visnIds varchar(max),
	@stationIds varchar(max)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	BEGIN TRY
	SELECT Visns.VisnCode, Stations.Station3N, Stations.Station6A, Stations.StationName, KeyReplicationLogs.StationID, 
			KeyReplicationLogs.ReplicationDate, KeyReplicationLogs.ReplicatedByUserName, KeyReplicationLogs.KeyName
	FROM KeyReplicationLogs
		LEFT OUTER JOIN Stations ON KeyReplicationLogs.StationID = Stations.StationID  
		LEFT OUTER JOIN Visns ON Visns.VisnID = Stations.VisnID
	WHERE  (KeyReplicationLogs.StationID In(SELECT [Value] FROM ufnSplit(',', @stationIds)) OR @stationIds IS NULL)
		AND (Stations.VisnID In(SELECT [Value] FROM ufnSplit(',', @visnIds)) OR @visnIds IS NULL)
	ORDER BY  Visns.VisnID, Stations.Station3N, Stations.Station6A;
	END TRY

	BEGIN CATCH
		PRINT 'There was an error processing the detail replication logs report' + CHAR(13);
		SELECT * FROM dbo.ufnGetErrorInfo();
		EXEC uspRaiseErrorInfo;
	END CATCH
END