﻿USE [WebVRAM_Test]
GO

/****** Object:  StoredProcedure [dbo].[uspRptReplicationLogServiceSectionTEST]    Script Date: 10/9/2015 2:38:25 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO





-- =============================================
-- Description:	Returns detail data for from Key Replication logs for reporting.
--
-- Maintenance Log:
--
-- Update By     Update Date     Description
-- -----------     ---------     ----------------------------
-- =============================================
CREATE PROCEDURE [dbo].[uspRptReplicationLogServiceSectionTEST]
	-- Add the parameters for the stored procedure here
	@VistaService varchar(max),
	@LogType varchar(max),
	@RemoteStation varchar(max)
	--@StartDate datetime2 (7),
	--@EndDate datetime2 (7)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	BEGIN TRY
	        
	    --Conditional Check 
        --If End date is less than begin date, set end date = begin date 
        --IF @EndDate  < @StartDate 
        --        BEGIN 
        --                SET @EndDate = @StartDate 
         --END
if object_Id ('tempdb..##VramTesting') is not null
DROP table ##VramTesting
  

SELECT 
 VU.StationID as 'UserStation'
,STb.Station3N as 'Station3NVU'
,STb.StationName as 'StationNameVU'
,STb.DisplayName as 'DisplayNameVU'
,V2.VisnCode as 'VisnCodeVU'
,V2.VisnName as 'VisnNameVU'
,VU.VistaUserFullName
,VU.VistaService
,RL.ReplicationID
,RL.ReplicationLogID
,R.ReplicationDate
,R.StationID as 'RemoteStation'
,STa.Station3N as 'Station3NR'
,STa.StationName as 'StationNameR'
,STa.DisplayName as 'DisplayNameR'
,V1.VisnCode as 'VisnCodeR'
,V1.VisnName as 'VisnNameR'
,R.VistaUserID
,RL.LogDate
,RL.LogType
,RL.ItemTypeID
,RL.ItemName
,RL.ErrorOccurred
,RL.LogMessage
,RL.LogDetails

into ##VramTesting 


 FROM WebVRAM_Test.dbo.ReplicationLogs RL

  INNER JOIN Replications R
  ON RL.ReplicationID = R.ReplicationID 

  INNER JOIN dbo.VistaUsers VU
  ON R.VistaUserID = VU.VistaUserID

  LEFT JOIN dbo.Stations STa
  ON R.StationID  = STa.StationID

  LEFT JOIN dbo.Visns V1
  ON STa.VisnId = V1.VisnId

  LEFT JOIN dbo.Stations STb
  ON VU.StationID  = STb.StationID

  LEFT JOIN dbo.Visns V2
  ON STb.VisnId = V2.VisnId


  

  --WHERE 
  --(VistaService In(SELECT [Value] FROM ufnSplit(',', @VistaService)) OR @VistaService IS NULL)
  --AND (LogType In(SELECT [Value] FROM ufnSplit(',', @LogType)) OR @LogType IS NULL)
  --AND (R.StationID In(SELECT [Value] FROM ufnSplit(',', @RemoteStation)) OR @RemoteStation IS NULL)
  --AND  ReplicationDate Between @StartDate AND @EndDate


  select a.*
from ##VramTesting a

inner join (
select Station3NVU, VistaService, VistaUserFullName, Station3NR   , max (ReplicationDate) as 'RepDAte'
from ##VramTesting 
group by  Station3NVU, VistaService, VistaUserFullName, Station3NR
) b
on a.Station3NVU = b.Station3NVU
and a.VistaService = b.VistaService
and a.VistaUserFullName = b.VistaUserFullName
and a.Station3NR = b.Station3NR
and a.ReplicationDAte = b.RepDate


  WHERE 
  (a.VistaService In(SELECT [Value] FROM ufnSplit(',', @VistaService)) OR @VistaService IS NULL)
  AND (a.LogType In(SELECT [Value] FROM ufnSplit(',', @LogType)) OR @LogType IS NULL)
  AND (a.Station3NR In(SELECT [Value] FROM ufnSplit(',', @RemoteStation)) OR @RemoteStation IS NULL)
  --AND  ReplicationDate Between @StartDate AND @EndDate  ---- Not needed anymore for actionable records


END TRY





	BEGIN CATCH
		PRINT 'There was an error processing the detail replication logs report' + CHAR(13)
		SELECT * FROM dbo.ufnGetErrorInfo()
		EXEC uspRaiseErrorInfo
	END CATCH
END




GO


