﻿
-- =============================================
-- Description:      Returns pivot results of count of income verifications by closed reason.
-- =============================================
CREATE PROCEDURE [dbo].uspSaveRptParameters
	@userId int,
	@RequestPage varchar(100),
	@WebMessage varchar(400)

AS

DECLARE 
	@username varchar(60),
	@addomain varchar(20);
SELECT 
    @username = UserName,
    @addomain = ADDOmain
FROM
    Users
WHERE
    UserID = @userId;

BEGIN

	BEGIN TRY
	
	INSERT INTO WebLogs( 
			ADDomain, 
			UserName, 
			RequestDate, 
			RemoteAddress, 
			RequestPage, 
			ActionType, 
			RecordID, 
			WebMessage)

		VALUES ( 
			@addomain, 
			@username, 
			GETDATE(), 
			null, 
			@RequestPage, 
			'Report Access', 
			null, 	
			@WebMessage )	;

	END TRY

	BEGIN CATCH
		PRINT 'There was an error processing the uspSaveRptParameters' + CHAR(13) ;
		SELECT * FROM dbo.ufnGetErrorInfo();
		EXEC uspRaiseErrorInfo;
	END CATCH

END

GO


