﻿--leaving a bunch of fields in, showing how can expand to have stations (parent stations) and CBOCs/clinics
CREATE TABLE dbo.Stations
(
	--fields
	StationID			[smallint] IDENTITY(1,1) NOT NULL,
	ParentStationID		[smallint],
	VisnID				[tinyint],
				--StateID				[tinyint],
	Station3N			[varchar](10),
	Station6A			[varchar](10),
	StationName			[varchar](200) NOT NULL,
	ParentStationName	[varchar](200),
	DisplayName			[varchar](100),
				--Moniker				[varchar](5),
				--City				[varchar](100),
	ParentStation		[bit] NOT NULL,
	DateInactive		[datetime2](7),
	Inactive			[bit] NOT NULL,
	StationIen			[varchar](10) NULL,
	StationOffline		[bit] NOT NULL,
	IsTestStation		[bit] NOT NULL,

	--primary key
	CONSTRAINT PK_Stations PRIMARY KEY CLUSTERED 
	(
		StationID ASC
	)
)
GO

--foreign keys
ALTER TABLE dbo.Stations
	ADD CONSTRAINT FK_Stations_Visns 
	FOREIGN KEY (VisnID)
	REFERENCES Visns (VisnID)
GO

ALTER TABLE dbo.Stations
	ADD CONSTRAINT FK_Stations_ParentStationID 
	FOREIGN KEY (ParentStationID)
	REFERENCES Stations (StationID)
GO

--indexes
CREATE NONCLUSTERED INDEX IX_Stations_VisnID ON dbo.Stations
	(
	VisnID
	) WITH( STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) 
GO

--constraints
--ALTER TABLE dbo.Stations
--   ADD CONSTRAINT DF_Stations_AdministrativeStation
--   DEFAULT 0
--   FOR AdministrativeStation
--GO

ALTER TABLE dbo.Stations
   ADD CONSTRAINT DF_Stations_Inactive
   DEFAULT 0
   FOR Inactive
GO

ALTER TABLE dbo.Stations
   ADD CONSTRAINT DF_Stations_IsTestStation
   DEFAULT 0
   FOR IsTestStation
GO

ALTER TABLE dbo.Stations
   ADD CONSTRAINT DF_Stations_StationOffline
   DEFAULT 0
   FOR StationOffline
GO

--Metadata descriptions for each field
EXECUTE sp_addextendedproperty 
N'MS_Description', N'Primary Key', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Stations', 
N'COLUMN', N'StationID'
GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'Foreign Key, self-referential key', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Stations', 
N'COLUMN', N'ParentStationID'
GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'Foreign Key, relates to Visns table', 
N'SCHEMA', N'dbo', N'TABLE', N'Stations', N'COLUMN', N'VisnID'
GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'3-digit numeric code for the Station', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Stations', 
N'COLUMN', N'Station3N'
GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'6-digit code for the Station', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Stations', 
N'COLUMN', N'Station6A'
GO

--EXECUTE sp_addextendedproperty 
--N'MS_Description', N'3-digit alpha code for the Station', 
--N'SCHEMA', N'dbo', 
--N'TABLE', N'Stations', 
--N'COLUMN', N'Moniker'
--GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'Name for the Station', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Stations', 
N'COLUMN', N'StationName'
GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'Name for the parent Station', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Stations', 
N'COLUMN', N'ParentStationName'
GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'Shorter name for the Station, primarily meant to be used in web controls', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Stations', 
N'COLUMN', N'DisplayName'
GO

--EXECUTE sp_addextendedproperty 
--N'MS_Description', N'City where the Station is located', 
--N'SCHEMA', N'dbo', 
--N'TABLE', N'Stations', 
--N'COLUMN', N'City'
--GO

--EXECUTE sp_addextendedproperty 
--N'MS_Description', N'Foreign key, related to States table', 
--N'SCHEMA', N'dbo', 
--N'TABLE', N'Stations', 
--N'COLUMN', N'StateID'
--GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'True/False that identifies if the Station is a parent Station', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Stations', 
N'COLUMN', N'ParentStation'
GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'Date record was inactivated', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Stations', 
N'COLUMN', N'DateInactive'
GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'Identifies if the record is inactive', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Stations', 
N'COLUMN', N'Inactive'
GO