﻿CREATE TABLE dbo.Visns
(
	--fields
	VisnID			[tinyint] NOT NULL,	--set to non-identity seeding so we can set pre-populate the ID with the same value as the VISN code
	RegionID		[tinyint],
	AltRegionID		[tinyint],
	VisnCode		[varchar](10),
	VisnName		[varchar](100) NOT NULL,
	Description		[varchar](200),
	DateInactive	[datetime2](7),
	Inactive		[bit] NOT NULL,

	--primary key
	CONSTRAINT PK_Visns PRIMARY KEY CLUSTERED 
	(
		VisnID ASC
	)
) 
GO

--foreign keys
ALTER TABLE dbo.Visns
	ADD CONSTRAINT FK_Visns_RegionID
	FOREIGN KEY (RegionID)
	REFERENCES Regions (RegionID)
GO

ALTER TABLE dbo.Visns
	ADD CONSTRAINT FK_Visns_AltRegionID 
	FOREIGN KEY (AltRegionID)
	REFERENCES Regions (RegionID)
GO

--indexes

--constraints

--Metadata descriptions for each field
EXECUTE sp_addextendedproperty 
N'MS_Description', N'Unique Key for the table', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Visns', 
N'COLUMN', N'VisnID'
GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'Foreign Key, relates to Regions table, what most VA uses',  
N'SCHEMA', N'dbo', 
N'TABLE', N'Visns', 
N'COLUMN', N'RegionID'
GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'Foreign Key, relates to Regions table, alternate region',  
N'SCHEMA', N'dbo', 
N'TABLE', N'Visns', 
N'COLUMN', N'AltRegionID'
GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'Abbreviation for the Visn', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Visns', 
N'COLUMN', N'VisnCode'
GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'Name of the Visn', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Visns', 
N'COLUMN', N'VisnName'
GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'Lengthier description of the Visn', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Visns', 
N'COLUMN', N'Description'
GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'Date record was inactivated', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Visns', 
N'COLUMN', N'DateInactive'
GO

EXECUTE sp_addextendedproperty 
N'MS_Description', N'Identifies if the record is inactive', 
N'SCHEMA', N'dbo', 
N'TABLE', N'Visns', 
N'COLUMN', N'Inactive'
GO