﻿using System;
using System.Threading.Tasks;

namespace WebVRAM.Data.Repository
{
    public interface IUnitOfWork
    {
        void Dispose();
        GenericRepository<T> GetRepository<T>() where T : class;
        UserRepository UserRepository { get; }
        UserRolesRepository UserRolesRepository { get; }
        WebLogsRepository WebLogsRepository { get; }
        VistaUserRepository VistaUserRepository { get; }

        StationsRepository StationsRepository { get; }
        
        int Save();
        Task<int> SaveAsync();
    }
}
