﻿using System.Collections.Generic;
using System.Linq;
using LinqKit;
using WebVRAM.Data.Domain;

namespace WebVRAM.Data.Repository
{
    public class StationsRepository : GenericRepository<Station>
    {
        public StationsRepository(WebVRAM_Entities context)
        {
            Context = context;
            DbSet = context.Set<Station>();
        }

        public Dictionary<string, bool> GetTestStationExpectations(IEnumerable<string> vistaTestSiteIens)
        {
            var predicate = PredicateBuilder.False<Station>();

            foreach (var vistaTestSiteIen in vistaTestSiteIens)
            {
                var stationIen = vistaTestSiteIen;
                if(!string.IsNullOrEmpty(stationIen))
                    predicate = predicate.Or(station => station.StationIen == stationIen);
            }

            var stations = Context.Stations.AsExpandable().Where(predicate);

            return stations.ToDictionary(station => station.StationIen, station => station.StationOffline);
        }
    }
}