﻿using System.Linq;
using WebVRAM.Data.Domain;

namespace WebVRAM.Data.Repository
{
    public class VistaUserRepository : GenericRepository<VistaUser>
    {
        public VistaUserRepository(WebVRAM_Entities context)
        {
            Context = context;
            DbSet = context.Set<VistaUser>();
        }

        public VistaUser GetVistaUser(string adDomain, string userName, string vistaUserIen)
        {
            return
                Get(u => u.ADDomain == adDomain && u.ADUsername == userName && u.VistaUserIEN == vistaUserIen)
                    .FirstOrDefault();
        }

        public VistaUser GetVistaUserByIen(string vistaUserIen)
        {
            return Get(u => u.VistaUserIEN == vistaUserIen).FirstOrDefault();
        }
    }
}