﻿using System.Net;
using System.Net.Http;
using System.Threading.Tasks;
using Xunit;

namespace WebVRAM.Web.ng.Test.IntegrationTests
{
    public class TestControllerTests : IClassFixture<TestFixture<Startup>>
    {
        private readonly HttpClient _httpClient;
        
        public TestControllerTests(TestFixture<Startup> testFixture)
        {
            _httpClient = testFixture.Client;
        }

        [Fact]
        public async Task HttpGet_GetReturn()
        {
            // Arrange
            
            // Act
            var response = await _httpClient.GetAsync("/api/test");
            
            // Assert
            Assert.Equal(HttpStatusCode.OK, response.StatusCode);

            var content = await response.Content.ReadAsStringAsync();
            Assert.Equal("httpGet", content);
        }
    }
}