﻿using Microsoft.AspNetCore.Authentication.JwtBearer;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;

namespace WebVRAM.Web.ng.Controllers
{
    [ApiController]
    [Route("api/[controller]")]
    [Authorize(Policy = JwtBearerDefaults.AuthenticationScheme)]
    public class BaseApiController<T> : Controller
    {
        protected ILogger<T> _logger;
        
        public BaseApiController(ILogger<T> logger)
        {
            _logger = logger;
        }
    }
}