﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using WebVRAM.Web.ng.Models;

namespace WebVRAM.Web.ng.Controllers
{
    [AllowAnonymous]
    public class ConfigController : BaseApiController<ConfigController>
    {
        public ConfigController(ILogger<ConfigController> logger) : base(logger)
        {
        }

        /// <summary>
        /// Provides the configuration necessary for Angular to boot up
        /// </summary>
        /// <returns></returns>
        [HttpGet]
        public IActionResult GetConfig()
        {
            var angularConfig = new AngularConfig();

            return Ok(angularConfig);
        }
    }
}