using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using WebVRAM.Vista.Service.Models;
using WebVRAM.Vista.Service;
using WebVRAM.Vista.Services;

namespace WebVRAM.Web.ng.Controllers
{
    public class VistaUserController : BaseApiController<VistaUserController>
    {
        private VistaUserService _vistaUserService;
        
        public VistaUserController(ILogger<VistaUserController> logger, VistaUserService vistaUserService) : base(logger)
        {
            _vistaUserService = vistaUserService;
        }

        [HttpGet("getVistaUserDetails")]
        public IActionResult GetVistaUserDetails()
        {
            return Ok(_vistaUserService.GetVistaUser());
        }

        [HttpGet("isElectronicSignatureCodeSet")]
        public IActionResult IsElectronicSignatureCodeSet()
        {
            return Ok(_vistaUserService.IsElectronicSignatureCodeSet());
        }

        [HttpPost("setElectronicSignatureCode")]
        public IActionResult SetElectronicSignatureCode([FromBody] string newElectronicSignatureCode)
        {
            return Ok(_vistaUserService.SetElectronicSignatureCode(newElectronicSignatureCode));
        }

        [HttpGet("getElectronicSignatureDetails")]
        public IActionResult GetElectronicSignatureDetails()
        {
            return Ok(_vistaUserService.GetElectronicSignatureDetails());
        }

        [HttpPost("setElectronicSignatureDetails")]
        public IActionResult SetElectronicSignatureDetails(ElectronicSignatureDetails electronicSignatureDetails)
        {
            return Ok(_vistaUserService.SetElectronicSignatureDetails(electronicSignatureDetails));
        }
    }
}