﻿(function() {
    'use strict';
    
    function ApplicationController($scope, $log, $timeout, $location, SessionService) {

        $scope.$on(EVENTS.LOGGED_IN, function(event, personName) {
            $scope.personName = personName;
        });

        $scope.$on(EVENTS.LOGGED_OUT, function(event) {
            $scope.personName = null;

            SessionService.Clear();

            $timeout(function() {
                $location.path('/login');
            }, 4000);

            if (APP.IAM_ENABLED) {
                window.location.href = IamConfig.LandingPage;
            }
        });
    }

    angular
        .module('WebVRAM')
        .controller('ApplicationController', ['$scope', '$log', '$timeout', '$location', 'SessionService', ApplicationController]);
})();