﻿(function () {
    'use strict';

    function IdleController($scope, $location, $timeout, $log, $modal, $http, Idle) {
        $scope.events = [];

        var idleModal = $modal({
            scope: $scope,
            templateUrl: 'ng/views/modals/idle-warning.tpl.html',
            show: false,
            backdrop: true
        });

        $scope.$on('IdleStart', function () {
            // the user appears to have gone idle
            $log.debug("IdleStart");

            idleModal.$promise.then(idleModal.show);
        });

        $scope.$on('IdleWarn', function (e, countdown) {
            // follows after the IdleStart event, but includes a countdown until the user is considered timed out
            // the countdown arg is the number of seconds remaining until then.
            // you can change the title or display a warning dialog from here.
            // you can let them resume their session by calling Idle.watch()
            $log.debug("IdleWarn: " + e + " " + countdown);
        });

        $scope.$on('IdleTimeout', function () {
            // the user has timed out (meaning idleDuration + timeout has passed without any activity)
            // this is where you'd log them
            idleModal.$promise.then(idleModal.hide);

            $log.debug("IdleTimeout");
            $scope.$apply(function() {
                $location.path('/logout');
            });
        });

        $scope.$on('IdleEnd', function () {
            // the user has come back from AFK and is doing stuff. if you are warning them, you can use this to hide the dialog
            $log.debug("IdleEnd");

            idleModal.$promise.then(idleModal.hide);
        });

        $scope.$on('Keepalive', function () {
            // do something to keep the user's session alive
            $log.debug("Keepalive");
        });        
    };

    angular
        .module('WebVRAM')
        .controller('IdleController', ['$scope', '$location', '$timeout', '$log', '$modal', '$http', 'Idle', IdleController]);
})();