﻿(function () {
    'use strict';

    function LoginController($scope, $rootScope, $location, $timeout, $log, SessionService, VistaService) {
        
        $scope.login = function (accessCode, verifyCode, changeVerifyCode) {
            if (typeof (verifyCode) === "undefined")
                verifyCode = '';

            var xsrf = $('meta[name=xsrf]').attr("content");

            VistaService.Login(accessCode, verifyCode, xsrf).then(function (response) {                
                if (!response.data.error) {
                    $scope.$emit(EVENTS.LOGGED_IN, response.data.personName);

                    SessionService.Set(SESSION.PERSON_NAME, response.data.personName);
                    SessionService.Set(SESSION.JWT, response.data.jwtToken);

                    $log.debug("logged in!");

                    $location.path('/main');
                } else {
                    alert(response.data.error);
                    $log.error(response);
                }
            }, function(response) {
                if (response.status === 401) {
                    alert('Invalid Access or Verify Code');
                }
                else if (response.status === -1) {
                    alert('WebVRAM appears to be offline.');
                }

                $log.error(response);
            });
        };

        VistaService.GetMessageOfTheDay(function (response) {
            if (response.status !== 200) {
                $scope.motd = "ERROR: Unable to fetch welcome message from the Claims VistA system";
                $log.error(response);
            } else {
                $scope.motd = response.data;
            }            
        });

        $('#accessCode').focus();
    };

    angular
        .module('WebVRAM')
        .controller('LoginController', ['$scope', '$rootScope', '$location', '$timeout', '$log', 'SessionService',
            'VistaService', LoginController]);
})();