﻿(function() {
    'use strict';

    function SignatureController($scope, VistaService) {

        $('#eSignatureModal').on('shown.bs.modal', function(e) {
            $("#eSignature").focus();
        });

        $('#eSignatureModal').on('hidden.bs.modal', function (e) {
            $scope.eSignature = '';
            $scope.eSignatureConfirm = '';

            $scope.form.$setPristine();
        });

        $scope.saveCode = function () {
            showSpin();

            VistaService.SetSignatureCode($scope.eSignatureConfirm).then(function(response) {                
                $('#eSignatureModal').modal('hide');
            }, function (response) {
                if (response.status > 0)
                    alert(response.data.Message);
                else
                    alert('WebVRAM appears to be offline.');

                $scope.eSignature = '';
                $scope.eSignatureConfirm = '';

                $scope.form.$setPristine();
            }).finally(function() {
                hideSpin();
            });            
        };

        /* -------------------------------------------------------- */

        $scope.signatureDetails = null;

        $("#eSignatureDetailsModal").on('show.bs.modal', function(e) {
            showSpin();
            VistaService.GetSignatureDetails().then(function (response) {
                $scope.signatureDetails = response.data;
                $scope.detailsForm.$setPristine();
                $("#eSignatureName").focus();
            }, function (response) {
                if (response.status === 400) {
                    alert(response.data.Message);
                } else {
                    console.error(response);
                    alert('Unable to fetch eSignature details');
                }                
            }).finally(function() {
                hideSpin();
            });
        });

        $scope.saveDetails = function () {
            showSpin();
            VistaService.SetSignatureDetails($scope.signatureDetails).then(function (response) {
                $('#eSignatureDetailsModal').modal('hide');                
            }, function (response) {
                if (response.status === 400) {
                    alert(response.data.Message);
                } else {
                    console.error(response);
                    alert('WebVRAM was unable to update your eSignature details.');
                }
            }).finally(function() {
                hideSpin();
            });            
        };

    };

    angular
        .module('WebVRAM')
        .controller('SignatureController', ['$scope', 'VistaService', SignatureController]);

})();