﻿(function () {
    'use strict';

    function ProgressBarDirective($compile) {
        return {
            restrict: 'E',
            templateUrl: 'ng/templates/progressBar.tpl.html',
            link: function (scope, element, attrs) {
                
                if (typeof (attrs.type) !== "undefined") {
                    scope.type = attrs.type;
                }

                if (typeof (attrs.maxValue) !== "undefined") {
                    scope.maxValue = attrs.maxValue;
                } else {
                    scope.maxValue = 100;
                }

                scope.$watch('value', function(value) {
                    scope.percentComplete = +(100 * value / scope.maxValue).toFixed(2);
                });
            }
        };
    };

    angular
        .module('WebVRAM')
        .directive('progressBar', ['$compile', ProgressBarDirective]);
})();