﻿(function () {
    'use strict';

    function VistaDirective() {
        var template =
            //'<div class="btn-group">\r\n<button type="button" class="btn btn-primary dropdown-toggle" bs-dropdown data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">\r\n    <span class="caret"></span>\r\n     </button>\r\n  <ul class="dropdown-menu" role="menu">\r\n    <li><a ng-click="executeSync()">Synchronize Only</a></li>\r\n </ul>  <button type="button" class="btn btn-primary" ng-click="executeReflections()">Launch Reflection</button>\r\n  \r\n</div>';
            //'<div class="btn-group"><button type="button" class="btn btn-primary" ng-click="executeReflections()">Launch Reflection</button>\r\n<button type="button" class="btn btn-primary dropdown-toggle" bs-dropdown data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">\r\n    <span class="caret"></span>\r\n     </button>\r\n  <ul class="dropdown-menu" role="menu">\r\n    <li><a ng-click="executeCprs()">CPRS</a></li>\r\n </ul></div>';
            '<div class="btn-group">\r\n<button type="button" class="btn btn-primary" ng-click="executeReflections()">Launch Reflection</button>\r\n  \r\n</div>';

        return {
            restrict: 'E',
            scope: {
                system: '@',
                reflection: '&',
                sync: '&',
                cprs: '&'
            },
            template: template,
            controller: ['$scope', function($scope) {
                $scope.executeReflections = function () {
                    $scope.reflection()($scope.system, 'reflection');
                };
                $scope.executeSync = function() {
                    $scope.sync()($scope.system, 'sync');
                };
                $scope.executeCprs = function() {
                    $scope.cprs()($scope.system, 'cprs');
                };
            }]
        };
    };

    angular
        .module('WebVRAM')
        .directive('vista', VistaDirective);
})();